require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ATOMIC_H_)) {
    eval 'sub _MACHINE_ATOMIC_H_ () {1;}' unless defined(&_MACHINE_ATOMIC_H_);
    require 'sys/atomic_common.ph';
    eval 'sub isb () {
        eval q( &__asm  &__volatile(\\"isb\\" : : : \\"memory\\"));
    }' unless defined(&isb);
    eval 'sub dsb {
        my($opt) = @_;
	    eval q( &__asm  &__volatile(\\"dsb \\"  &__STRING($opt) : : : \\"memory\\"));
    }' unless defined(&dsb);
    eval 'sub dmb {
        my($opt) = @_;
	    eval q( &__asm  &__volatile(\\"dmb \\"  &__STRING($opt) : : : \\"memory\\"));
    }' unless defined(&dmb);
    eval 'sub mb () {
        eval q( &dmb( &sy));
    }' unless defined(&mb);
    eval 'sub wmb () {
        eval q( &dmb( &st));
    }' unless defined(&wmb);
    eval 'sub rmb () {
        eval q( &dmb( &ld));
    }' unless defined(&rmb);
    eval 'sub ATOMIC_OP {
        my($op, $asm_op, $bar, $a, $l) = @_;
	    eval q( &static  &__inline  &void  &atomic_$op &_$bar32( &volatile  &uint32_t * &p,  &uint32_t  &val) {  &uint32_t  &tmp; \'int\'  &res;  &__asm  &__volatile( \\"1: ld\\"$a\\"xr   %w0, [%2]      \\\\n\\" \\"   \\"$asm_op\\"  %w0, %w0, %w3  \\\\n\\" \\"   st\\"$l\\"xr   %w1, %w0, [%2] \\\\n\\" \\"   cbnz       %w1, 1b	\\\\n\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" ); }  &static  &__inline  &void  &atomic_$op &_$bar64( &volatile  &uint64_t * &p,  &uint64_t  &val) {  &uint64_t  &tmp; \'int\'  &res;  &__asm  &__volatile( \\"1: ld\\"$a\\"xr   %0, [%2]      \\\\n\\" \\"   \\"$asm_op\\"  %0, %0, %3    \\\\n\\" \\"   st\\"$l\\"xr   %w1, %0, [%2] \\\\n\\" \\"   cbnz       %w1, 1b       \\\\n\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &val) : \\"memory\\" ); });
    }' unless defined(&ATOMIC_OP);
    eval 'sub ATOMIC {
        my($op, $asm_op) = @_;
	    eval q( &ATOMIC_OP($op, $asm_op, , , )  &ATOMIC_OP($op, $asm_op,  &acq_,  &a, )  &ATOMIC_OP($op, $asm_op,  &rel_, ,  &l));
    }' unless defined(&ATOMIC);
    eval 'sub ATOMIC_FCMPSET {
        my($bar, $a, $l) = @_;
	    eval q( &static  &__inline \'int\'  &atomic_fcmpset_$bar8( &volatile  &uint8_t * &p,  &uint8_t * &cmpval,  &uint8_t  &newval) {  &uint8_t  &tmp;  &uint8_t  &_cmpval = * &cmpval; \'int\'  &res;  &__asm  &__volatile( \\"1: mov      %w1, #1	\\\\n\\" \\"   ld\\"$a\\"xrb %w0, [%2]     \\\\n\\" \\"   cmp      %w0, %w3       \\\\n\\" \\"   b.ne     2f	     \\\\n\\" \\"   st\\"$l\\"xrb %w1, %w4, [%2]\\\\n\\" \\"2:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &_cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" ); * &cmpval =  &tmp;  &return (! &res); }  &static  &__inline \'int\'  &atomic_fcmpset_$bar16( &volatile  &uint16_t * &p,  &uint16_t * &cmpval,  &uint16_t  &newval) {  &uint16_t  &tmp;  &uint16_t  &_cmpval = * &cmpval; \'int\'  &res;  &__asm  &__volatile( \\"1: mov      %w1, #1	\\\\n\\" \\"   ld\\"$a\\"xh %w0, [%2]      \\\\n\\" \\"   cmp      %w0, %w3       \\\\n\\" \\"   b.ne     2f	     \\\\n\\" \\"   st\\"$l\\"xh %w1, %w4, [%2] \\\\n\\" \\"2:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &_cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" ); * &cmpval =  &tmp;  &return (! &res); }  &static  &__inline \'int\'  &atomic_fcmpset_$bar32( &volatile  &uint32_t * &p,  &uint32_t * &cmpval,  &uint32_t  &newval) {  &uint32_t  &tmp;  &uint32_t  &_cmpval = * &cmpval; \'int\'  &res;  &__asm  &__volatile( \\"1: mov      %w1, #1	\\\\n\\" \\"   ld\\"$a\\"xr %w0, [%2]      \\\\n\\" \\"   cmp      %w0, %w3       \\\\n\\" \\"   b.ne     2f	     \\\\n\\" \\"   st\\"$l\\"xr %w1, %w4, [%2] \\\\n\\" \\"2:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &_cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" ); * &cmpval =  &tmp;  &return (! &res); }  &static  &__inline \'int\'  &atomic_fcmpset_$bar64( &volatile  &uint64_t * &p,  &uint64_t * &cmpval,  &uint64_t  &newval) {  &uint64_t  &tmp;  &uint64_t  &_cmpval = * &cmpval; \'int\'  &res;  &__asm  &__volatile( \\"1: mov      %w1, #1       \\\\n\\" \\"   ld\\"$a\\"xr %0, [%2]      \\\\n\\" \\"   cmp      %0, %3	\\\\n\\" \\"   b.ne     2f	    \\\\n\\" \\"   st\\"$l\\"xr %w1, %4, [%2] \\\\n\\" \\"2:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &_cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" ); * &cmpval =  &tmp;  &return (! &res); });
    }' unless defined(&ATOMIC_FCMPSET);
    undef(&ATOMIC_FCMPSET) if defined(&ATOMIC_FCMPSET);
    eval 'sub ATOMIC_CMPSET {
        my($bar, $a, $l) = @_;
	    eval q( &static  &__inline \'int\'  &atomic_cmpset_$bar32( &volatile  &uint32_t * &p,  &uint32_t  &cmpval,  &uint32_t  &newval) {  &uint32_t  &tmp; \'int\'  &res;  &__asm  &__volatile( \\"1: mov      %w1, #1	\\\\n\\" \\"   ld\\"$a\\"xr %w0, [%2]      \\\\n\\" \\"   cmp      %w0, %w3       \\\\n\\" \\"   b.ne     2f	     \\\\n\\" \\"   st\\"$l\\"xr %w1, %w4, [%2] \\\\n\\" \\"   cbnz     %w1, 1b	\\\\n\\" \\"2:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" );  &return (! &res); }  &static  &__inline \'int\'  &atomic_cmpset_$bar64( &volatile  &uint64_t * &p,  &uint64_t  &cmpval,  &uint64_t  &newval) {  &uint64_t  &tmp; \'int\'  &res;  &__asm  &__volatile( \\"1: mov      %w1, #1       \\\\n\\" \\"   ld\\"$a\\"xr %0, [%2]      \\\\n\\" \\"   cmp      %0, %3	\\\\n\\" \\"   b.ne     2f	    \\\\n\\" \\"   st\\"$l\\"xr %w1, %4, [%2] \\\\n\\" \\"   cbnz     %w1, 1b       \\\\n\\" \\"2:\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res) : \\"r\\" ( &p), \\"r\\" ( &cmpval), \\"r\\" ( &newval) : \\"cc\\", \\"memory\\" );  &return (! &res); });
    }' unless defined(&ATOMIC_CMPSET);
    eval 'sub atomic_fetchadd_32 {
        my($p,$val) = @_;
	    eval q({  &uint32_t  &tmp,  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%w2, [%3]      \\\\n\\" \\"   add	%w0, %w2, %w4  \\\\n\\" \\"   stxr	%w1, %w0, [%3] \\\\n\\" \\"   cbnz	%w1, 1b	\\\\n\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res), \\"=&r\\"( &ret) : \\"r\\" ($p), \\"r\\" ($val) : \\"memory\\" ); ( &ret); });
    }' unless defined(&atomic_fetchadd_32);
    eval 'sub atomic_fetchadd_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &tmp,  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%2, [%3]      \\\\n\\" \\"   add	%0, %2, %4    \\\\n\\" \\"   stxr	%w1, %0, [%3] \\\\n\\" \\"   cbnz	%w1, 1b       \\\\n\\" : \\"=&r\\"( &tmp), \\"=&r\\"( &res), \\"=&r\\"( &ret) : \\"r\\" ($p), \\"r\\" ($val) : \\"memory\\" ); ( &ret); });
    }' unless defined(&atomic_fetchadd_64);
    eval 'sub atomic_readandclear_32 {
        my($p) = @_;
	    eval q({  &uint32_t  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%w1, [%2]      \\\\n\\" \\"   stxr	%w0, wzr, [%2] \\\\n\\" \\"   cbnz	%w0, 1b	\\\\n\\" : \\"=&r\\"( &res), \\"=&r\\"( &ret) : \\"r\\" ($p) : \\"memory\\" ); ( &ret); });
    }' unless defined(&atomic_readandclear_32);
    eval 'sub atomic_readandclear_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%1, [%2]      \\\\n\\" \\"   stxr	%w0, xzr, [%2] \\\\n\\" \\"   cbnz	%w0, 1b	\\\\n\\" : \\"=&r\\"( &res), \\"=&r\\"( &ret) : \\"r\\" ($p) : \\"memory\\" ); ( &ret); });
    }' unless defined(&atomic_readandclear_64);
    eval 'sub atomic_swap_32 {
        my($p,$val) = @_;
	    eval q({  &uint32_t  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%w0, [%2]      \\\\n\\" \\"   stxr	%w1, %w3, [%2] \\\\n\\" \\"   cbnz	%w1, 1b	\\\\n\\" : \\"=&r\\"( &ret), \\"=&r\\"( &res) : \\"r\\" ($p), \\"r\\" ($val) : \\"memory\\" ); ( &ret); });
    }' unless defined(&atomic_swap_32);
    eval 'sub atomic_swap_64 {
        my($p,$val) = @_;
	    eval q({  &uint64_t  &ret; \'int\'  &res;  &__asm  &__volatile( \\"1: ldxr	%0, [%2]      \\\\n\\" \\"   stxr	%w1, %3, [%2] \\\\n\\" \\"   cbnz	%w1, 1b       \\\\n\\" : \\"=&r\\"( &ret), \\"=&r\\"( &res) : \\"r\\" ($p), \\"r\\" ($val) : \\"memory\\" ); ( &ret); });
    }' unless defined(&atomic_swap_64);
    eval 'sub atomic_load_acq_32 {
        my($p) = @_;
	    eval q({  &uint32_t  &ret;  &__asm  &__volatile( \\"ldar	%w0, [%1] \\\\n\\" : \\"=&r\\" ( &ret) : \\"r\\" ($p) : \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_load_acq_32);
    eval 'sub atomic_load_acq_64 {
        my($p) = @_;
	    eval q({  &uint64_t  &ret;  &__asm  &__volatile( \\"ldar	%0, [%1] \\\\n\\" : \\"=&r\\" ( &ret) : \\"r\\" ($p) : \\"memory\\"); ( &ret); });
    }' unless defined(&atomic_load_acq_64);
    eval 'sub atomic_store_rel_32 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile( \\"stlr	%w0, [%1] \\\\n\\" : : \\"r\\" ($val), \\"r\\" ($p) : \\"memory\\"); });
    }' unless defined(&atomic_store_rel_32);
    eval 'sub atomic_store_rel_64 {
        my($p,$val) = @_;
	    eval q({  &__asm  &__volatile( \\"stlr	%0, [%1] \\\\n\\" : : \\"r\\" ($val), \\"r\\" ($p) : \\"memory\\"); });
    }' unless defined(&atomic_store_rel_64);
    eval 'sub atomic_add_int () { &atomic_add_32;}' unless defined(&atomic_add_int);
    eval 'sub atomic_fcmpset_int () { &atomic_fcmpset_32;}' unless defined(&atomic_fcmpset_int);
    eval 'sub atomic_clear_int () { &atomic_clear_32;}' unless defined(&atomic_clear_int);
    eval 'sub atomic_cmpset_int () { &atomic_cmpset_32;}' unless defined(&atomic_cmpset_int);
    eval 'sub atomic_fetchadd_int () { &atomic_fetchadd_32;}' unless defined(&atomic_fetchadd_int);
    eval 'sub atomic_readandclear_int () { &atomic_readandclear_32;}' unless defined(&atomic_readandclear_int);
    eval 'sub atomic_set_int () { &atomic_set_32;}' unless defined(&atomic_set_int);
    eval 'sub atomic_swap_int () { &atomic_swap_32;}' unless defined(&atomic_swap_int);
    eval 'sub atomic_subtract_int () { &atomic_subtract_32;}' unless defined(&atomic_subtract_int);
    eval 'sub atomic_add_acq_int () { &atomic_add_acq_32;}' unless defined(&atomic_add_acq_int);
    eval 'sub atomic_fcmpset_acq_int () { &atomic_fcmpset_acq_32;}' unless defined(&atomic_fcmpset_acq_int);
    eval 'sub atomic_clear_acq_int () { &atomic_clear_acq_32;}' unless defined(&atomic_clear_acq_int);
    eval 'sub atomic_cmpset_acq_int () { &atomic_cmpset_acq_32;}' unless defined(&atomic_cmpset_acq_int);
    eval 'sub atomic_load_acq_int () { &atomic_load_acq_32;}' unless defined(&atomic_load_acq_int);
    eval 'sub atomic_set_acq_int () { &atomic_set_acq_32;}' unless defined(&atomic_set_acq_int);
    eval 'sub atomic_subtract_acq_int () { &atomic_subtract_acq_32;}' unless defined(&atomic_subtract_acq_int);
    eval 'sub atomic_add_rel_int () { &atomic_add_rel_32;}' unless defined(&atomic_add_rel_int);
    eval 'sub atomic_fcmpset_rel_int () { &atomic_fcmpset_rel_32;}' unless defined(&atomic_fcmpset_rel_int);
    eval 'sub atomic_clear_rel_int () { &atomic_clear_rel_32;}' unless defined(&atomic_clear_rel_int);
    eval 'sub atomic_cmpset_rel_int () { &atomic_cmpset_rel_32;}' unless defined(&atomic_cmpset_rel_int);
    eval 'sub atomic_set_rel_int () { &atomic_set_rel_32;}' unless defined(&atomic_set_rel_int);
    eval 'sub atomic_subtract_rel_int () { &atomic_subtract_rel_32;}' unless defined(&atomic_subtract_rel_int);
    eval 'sub atomic_store_rel_int () { &atomic_store_rel_32;}' unless defined(&atomic_store_rel_int);
    eval 'sub atomic_add_long () { &atomic_add_64;}' unless defined(&atomic_add_long);
    eval 'sub atomic_fcmpset_long () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_long);
    eval 'sub atomic_clear_long () { &atomic_clear_64;}' unless defined(&atomic_clear_long);
    eval 'sub atomic_cmpset_long () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_long);
    eval 'sub atomic_fetchadd_long () { &atomic_fetchadd_64;}' unless defined(&atomic_fetchadd_long);
    eval 'sub atomic_readandclear_long () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_long);
    eval 'sub atomic_set_long () { &atomic_set_64;}' unless defined(&atomic_set_long);
    eval 'sub atomic_swap_long () { &atomic_swap_64;}' unless defined(&atomic_swap_long);
    eval 'sub atomic_subtract_long () { &atomic_subtract_64;}' unless defined(&atomic_subtract_long);
    eval 'sub atomic_add_ptr () { &atomic_add_64;}' unless defined(&atomic_add_ptr);
    eval 'sub atomic_fcmpset_ptr () { &atomic_fcmpset_64;}' unless defined(&atomic_fcmpset_ptr);
    eval 'sub atomic_clear_ptr () { &atomic_clear_64;}' unless defined(&atomic_clear_ptr);
    eval 'sub atomic_cmpset_ptr () { &atomic_cmpset_64;}' unless defined(&atomic_cmpset_ptr);
    eval 'sub atomic_fetchadd_ptr () { &atomic_fetchadd_64;}' unless defined(&atomic_fetchadd_ptr);
    eval 'sub atomic_readandclear_ptr () { &atomic_readandclear_64;}' unless defined(&atomic_readandclear_ptr);
    eval 'sub atomic_set_ptr () { &atomic_set_64;}' unless defined(&atomic_set_ptr);
    eval 'sub atomic_swap_ptr () { &atomic_swap_64;}' unless defined(&atomic_swap_ptr);
    eval 'sub atomic_subtract_ptr () { &atomic_subtract_64;}' unless defined(&atomic_subtract_ptr);
    eval 'sub atomic_add_acq_long () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_long);
    eval 'sub atomic_fcmpset_acq_long () { &atomic_fcmpset_acq_64;}' unless defined(&atomic_fcmpset_acq_long);
    eval 'sub atomic_clear_acq_long () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_long);
    eval 'sub atomic_cmpset_acq_long () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_long);
    eval 'sub atomic_load_acq_long () { &atomic_load_acq_64;}' unless defined(&atomic_load_acq_long);
    eval 'sub atomic_set_acq_long () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_long);
    eval 'sub atomic_subtract_acq_long () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_long);
    eval 'sub atomic_add_acq_ptr () { &atomic_add_acq_64;}' unless defined(&atomic_add_acq_ptr);
    eval 'sub atomic_fcmpset_acq_ptr () { &atomic_fcmpset_acq_64;}' unless defined(&atomic_fcmpset_acq_ptr);
    eval 'sub atomic_clear_acq_ptr () { &atomic_clear_acq_64;}' unless defined(&atomic_clear_acq_ptr);
    eval 'sub atomic_cmpset_acq_ptr () { &atomic_cmpset_acq_64;}' unless defined(&atomic_cmpset_acq_ptr);
    eval 'sub atomic_load_acq_ptr () { &atomic_load_acq_64;}' unless defined(&atomic_load_acq_ptr);
    eval 'sub atomic_set_acq_ptr () { &atomic_set_acq_64;}' unless defined(&atomic_set_acq_ptr);
    eval 'sub atomic_subtract_acq_ptr () { &atomic_subtract_acq_64;}' unless defined(&atomic_subtract_acq_ptr);
    eval 'sub atomic_add_rel_long () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_long);
    eval 'sub atomic_fcmpset_rel_long () { &atomic_fcmpset_rel_64;}' unless defined(&atomic_fcmpset_rel_long);
    eval 'sub atomic_clear_rel_long () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_long);
    eval 'sub atomic_cmpset_rel_long () { &atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_long);
    eval 'sub atomic_set_rel_long () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_long);
    eval 'sub atomic_subtract_rel_long () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_long);
    eval 'sub atomic_store_rel_long () { &atomic_store_rel_64;}' unless defined(&atomic_store_rel_long);
    eval 'sub atomic_add_rel_ptr () { &atomic_add_rel_64;}' unless defined(&atomic_add_rel_ptr);
    eval 'sub atomic_fcmpset_rel_ptr () { &atomic_fcmpset_rel_64;}' unless defined(&atomic_fcmpset_rel_ptr);
    eval 'sub atomic_clear_rel_ptr () { &atomic_clear_rel_64;}' unless defined(&atomic_clear_rel_ptr);
    eval 'sub atomic_cmpset_rel_ptr () { &atomic_cmpset_rel_64;}' unless defined(&atomic_cmpset_rel_ptr);
    eval 'sub atomic_set_rel_ptr () { &atomic_set_rel_64;}' unless defined(&atomic_set_rel_ptr);
    eval 'sub atomic_subtract_rel_ptr () { &atomic_subtract_rel_64;}' unless defined(&atomic_subtract_rel_ptr);
    eval 'sub atomic_store_rel_ptr () { &atomic_store_rel_64;}' unless defined(&atomic_store_rel_ptr);
    eval 'sub atomic_thread_fence_acq {
        my($void) = @_;
	    eval q({  &dmb( &ld); });
    }' unless defined(&atomic_thread_fence_acq);
    eval 'sub atomic_thread_fence_rel {
        my($void) = @_;
	    eval q({  &dmb( &sy); });
    }' unless defined(&atomic_thread_fence_rel);
    eval 'sub atomic_thread_fence_acq_rel {
        my($void) = @_;
	    eval q({  &dmb( &sy); });
    }' unless defined(&atomic_thread_fence_acq_rel);
    eval 'sub atomic_thread_fence_seq_cst {
        my($void) = @_;
	    eval q({  &dmb( &sy); });
    }' unless defined(&atomic_thread_fence_seq_cst);
}
1;
