require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPU_H_)) {
    eval 'sub _MACHINE_CPU_H_ () {1;}' unless defined(&_MACHINE_CPU_H_);
    require 'machine/atomic.ph';
    require 'machine/frame.ph';
    require 'machine/armreg.ph';
    eval 'sub TRAPF_PC {
        my($tfp) = @_;
	    eval q((($tfp)-> &tf_lr));
    }' unless defined(&TRAPF_PC);
    eval 'sub TRAPF_USERMODE {
        my($tfp) = @_;
	    eval q(((($tfp)-> &tf_spsr &  &PSR_M_MASK) ==  &PSR_M_EL0t));
    }' unless defined(&TRAPF_USERMODE);
    eval 'sub cpu_getstack {
        my($td) = @_;
	    eval q((($td)-> ($td_frame->{tf_sp})));
    }' unless defined(&cpu_getstack);
    eval 'sub cpu_setstack {
        my($td, $sp) = @_;
	    eval q((($td)-> ($td_frame->{tf_sp}) = ($sp)));
    }' unless defined(&cpu_setstack);
    eval 'sub cpu_spinwait () {
        eval q( &__asm  &__volatile(\\"yield\\" ::: \\"memory\\"));
    }' unless defined(&cpu_spinwait);
    eval 'sub cpu_lock_delay () {
        eval q( &DELAY(1));
    }' unless defined(&cpu_lock_delay);
    eval 'sub CPU_AFF0 {
        my($mpidr) = @_;
	    eval q(((($mpidr) >> 0) & 0xff));
    }' unless defined(&CPU_AFF0);
    eval 'sub CPU_AFF1 {
        my($mpidr) = @_;
	    eval q(((($mpidr) >> 8) & 0xff));
    }' unless defined(&CPU_AFF1);
    eval 'sub CPU_AFF2 {
        my($mpidr) = @_;
	    eval q(((($mpidr) >> 16) & 0xff));
    }' unless defined(&CPU_AFF2);
    eval 'sub CPU_AFF3 {
        my($mpidr) = @_;
	    eval q(((($mpidr) >> 32) & 0xff));
    }' unless defined(&CPU_AFF3);
    eval 'sub CPU_AFF0_MASK () {0xff;}' unless defined(&CPU_AFF0_MASK);
    eval 'sub CPU_AFF1_MASK () {0xff00;}' unless defined(&CPU_AFF1_MASK);
    eval 'sub CPU_AFF2_MASK () {0xff0000;}' unless defined(&CPU_AFF2_MASK);
    eval 'sub CPU_AFF3_MASK () {0xff00000000;}' unless defined(&CPU_AFF3_MASK);
    eval 'sub CPU_AFF_MASK () {( &CPU_AFF0_MASK |  &CPU_AFF1_MASK |  &CPU_AFF2_MASK|  &CPU_AFF3_MASK);}' unless defined(&CPU_AFF_MASK);
    if(defined(&_KERNEL)) {
	eval 'sub CPU_IMPL_ARM () {0x41;}' unless defined(&CPU_IMPL_ARM);
	eval 'sub CPU_IMPL_BROADCOM () {0x42;}' unless defined(&CPU_IMPL_BROADCOM);
	eval 'sub CPU_IMPL_CAVIUM () {0x43;}' unless defined(&CPU_IMPL_CAVIUM);
	eval 'sub CPU_IMPL_DEC () {0x44;}' unless defined(&CPU_IMPL_DEC);
	eval 'sub CPU_IMPL_INFINEON () {0x49;}' unless defined(&CPU_IMPL_INFINEON);
	eval 'sub CPU_IMPL_FREESCALE () {0x4d;}' unless defined(&CPU_IMPL_FREESCALE);
	eval 'sub CPU_IMPL_NVIDIA () {0x4e;}' unless defined(&CPU_IMPL_NVIDIA);
	eval 'sub CPU_IMPL_APM () {0x50;}' unless defined(&CPU_IMPL_APM);
	eval 'sub CPU_IMPL_QUALCOMM () {0x51;}' unless defined(&CPU_IMPL_QUALCOMM);
	eval 'sub CPU_IMPL_MARVELL () {0x56;}' unless defined(&CPU_IMPL_MARVELL);
	eval 'sub CPU_IMPL_INTEL () {0x69;}' unless defined(&CPU_IMPL_INTEL);
	eval 'sub CPU_PART_FOUNDATION () {0xd00;}' unless defined(&CPU_PART_FOUNDATION);
	eval 'sub CPU_PART_CORTEX_A35 () {0xd04;}' unless defined(&CPU_PART_CORTEX_A35);
	eval 'sub CPU_PART_CORTEX_A53 () {0xd03;}' unless defined(&CPU_PART_CORTEX_A53);
	eval 'sub CPU_PART_CORTEX_A55 () {0xd05;}' unless defined(&CPU_PART_CORTEX_A55);
	eval 'sub CPU_PART_CORTEX_A57 () {0xd07;}' unless defined(&CPU_PART_CORTEX_A57);
	eval 'sub CPU_PART_CORTEX_A72 () {0xd08;}' unless defined(&CPU_PART_CORTEX_A72);
	eval 'sub CPU_PART_CORTEX_A73 () {0xd09;}' unless defined(&CPU_PART_CORTEX_A73);
	eval 'sub CPU_PART_CORTEX_A75 () {0xd0a;}' unless defined(&CPU_PART_CORTEX_A75);
	eval 'sub CPU_PART_THUNDERX () {0xa1;}' unless defined(&CPU_PART_THUNDERX);
	eval 'sub CPU_PART_THUNDERX_81XX () {0xa2;}' unless defined(&CPU_PART_THUNDERX_81XX);
	eval 'sub CPU_PART_THUNDERX_83XX () {0xa3;}' unless defined(&CPU_PART_THUNDERX_83XX);
	eval 'sub CPU_PART_THUNDERX2 () {0xaf;}' unless defined(&CPU_PART_THUNDERX2);
	eval 'sub CPU_REV_THUNDERX_1_0 () {0x;}' unless defined(&CPU_REV_THUNDERX_1_0);
	eval 'sub CPU_REV_THUNDERX_1_1 () {0x1;}' unless defined(&CPU_REV_THUNDERX_1_1);
	eval 'sub CPU_REV_THUNDERX2_0 () {0x;}' unless defined(&CPU_REV_THUNDERX2_0);
	eval 'sub CPU_PART_EMAG8180 () {0x;}' unless defined(&CPU_PART_EMAG8180);
	eval 'sub CPU_IMPL {
	    my($midr) = @_;
    	    eval q(((($midr) >> 24) & 0xff));
	}' unless defined(&CPU_IMPL);
	eval 'sub CPU_PART {
	    my($midr) = @_;
    	    eval q(((($midr) >> 4) & 0xfff));
	}' unless defined(&CPU_PART);
	eval 'sub CPU_VAR {
	    my($midr) = @_;
    	    eval q(((($midr) >> 20) & 0xf));
	}' unless defined(&CPU_VAR);
	eval 'sub CPU_REV {
	    my($midr) = @_;
    	    eval q(((($midr) >> 0) & 0xf));
	}' unless defined(&CPU_REV);
	eval 'sub CPU_IMPL_TO_MIDR {
	    my($val) = @_;
    	    eval q(((($val) & 0xff) << 24));
	}' unless defined(&CPU_IMPL_TO_MIDR);
	eval 'sub CPU_PART_TO_MIDR {
	    my($val) = @_;
    	    eval q(((($val) & 0xfff) << 4));
	}' unless defined(&CPU_PART_TO_MIDR);
	eval 'sub CPU_VAR_TO_MIDR {
	    my($val) = @_;
    	    eval q(((($val) & 0xf) << 20));
	}' unless defined(&CPU_VAR_TO_MIDR);
	eval 'sub CPU_REV_TO_MIDR {
	    my($val) = @_;
    	    eval q(((($val) & 0xf) << 0));
	}' unless defined(&CPU_REV_TO_MIDR);
	eval 'sub CPU_IMPL_MASK () {(0xff << 24);}' unless defined(&CPU_IMPL_MASK);
	eval 'sub CPU_PART_MASK () {(0xfff << 4);}' unless defined(&CPU_PART_MASK);
	eval 'sub CPU_VAR_MASK () {(0xf << 20);}' unless defined(&CPU_VAR_MASK);
	eval 'sub CPU_REV_MASK () {(0xf << 0);}' unless defined(&CPU_REV_MASK);
	eval 'sub CPU_ID_RAW {
	    my($impl, $part, $var, $rev) = @_;
    	    eval q(( &CPU_IMPL_TO_MIDR(($impl)) |  &CPU_PART_TO_MIDR(($part)) |  &CPU_VAR_TO_MIDR(($var)) |  &CPU_REV_TO_MIDR(($rev))));
	}' unless defined(&CPU_ID_RAW);
	eval 'sub CPU_MATCH {
	    my($mask, $impl, $part, $var, $rev) = @_;
    	    eval q(((($mask) &  &PCPU_GET( &midr)) == (($mask) &  &CPU_ID_RAW(($impl), ($part), ($var), ($rev)))));
	}' unless defined(&CPU_MATCH);
	eval 'sub CPU_MATCH_RAW {
	    my($mask, $devid) = @_;
    	    eval q(((($mask) &  &PCPU_GET( &midr)) == (($mask) & ($devid))));
	}' unless defined(&CPU_MATCH_RAW);
	if(defined(&THUNDERX_PASS_1_1_ERRATA)) {
	    eval 'sub CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1 () {( &CPU_MATCH( &CPU_IMPL_MASK |  &CPU_PART_MASK |  &CPU_REV_MASK,  &CPU_IMPL_CAVIUM,  &CPU_PART_THUNDERX, 0,  &CPU_REV_THUNDERX_1_0) ||  &CPU_MATCH( &CPU_IMPL_MASK |  &CPU_PART_MASK |  &CPU_REV_MASK,  &CPU_IMPL_CAVIUM,  &CPU_PART_THUNDERX, 0,  &CPU_REV_THUNDERX_1_1));}' unless defined(&CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1);
	} else {
	    eval 'sub CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1 () {0;}' unless defined(&CPU_MATCH_ERRATA_CAVIUM_THUNDERX_1_1);
	}
	eval 'sub CPU_AFFINITY {
	    my($cpu) = @_;
    	    eval q( $__cpu_affinity[($cpu)]);
	}' unless defined(&CPU_AFFINITY);
	eval 'sub CPU_CURRENT_SOCKET () {( &CPU_AFF2( &CPU_AFFINITY( &PCPU_GET( &cpuid))));}' unless defined(&CPU_CURRENT_SOCKET);
	eval 'sub get_cyclecount {
	    my($void) = @_;
    	    eval q({  &uint64_t  &ret;  &ret =  &READ_SPECIALREG( &cntvct_el0); ( &ret); });
	}' unless defined(&get_cyclecount);
	eval 'sub ADDRESS_TRANSLATE_FUNC {
	    my($stage) = @_;
    	    eval q( &static  &inline  &uint64_t  &arm64_address_translate_ $stage ( &uint64_t  &addr) {  &uint64_t  &ret;  &__asm  &__volatile( \\"at \\"  &__STRING($stage) \\", %1 \\\\n\\" \\"mrs %0, par_el1\\" : \\"=r\\"( &ret) : \\"r\\"( &addr));  &return ( &ret); });
	}' unless defined(&ADDRESS_TRANSLATE_FUNC);
    }
}
1;
