require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPUFUNC_H_)) {
    eval 'sub _MACHINE_CPUFUNC_H_ () {1;}' unless defined(&_MACHINE_CPUFUNC_H_);
    eval 'sub breakpoint {
        my($void) = @_;
	    eval q({  &__asm(\\"brk #0\\"); });
    }' unless defined(&breakpoint);
    if(defined(&_KERNEL)) {
	require 'machine/armreg.ph';
	eval 'sub dbg_disable {
	    my($void) = @_;
    	    eval q({  &uint32_t  &ret;  &__asm  &__volatile( \\"mrs %x0, daif   \\\\n\\" \\"msr daifset, #8 \\\\n\\" : \\"=&r\\" ( &ret)); ( &ret); });
	}' unless defined(&dbg_disable);
	eval 'sub dbg_enable {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"msr daifclr, #8\\"); });
	}' unless defined(&dbg_enable);
	eval 'sub intr_disable {
	    my($void) = @_;
    	    eval q({  &uint32_t  &ret;  &__asm  &__volatile( \\"mrs %x0, daif   \\\\n\\" \\"msr daifset, #2 \\\\n\\" : \\"=&r\\" ( &ret)); ( &ret); });
	}' unless defined(&intr_disable);
	eval 'sub intr_restore {
	    my($s) = @_;
    	    eval q({  &WRITE_SPECIALREG( &daif, $s); });
	}' unless defined(&intr_restore);
	eval 'sub intr_enable {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"msr daifclr, #2\\"); });
	}' unless defined(&intr_enable);
	eval 'sub get_midr {
	    my($void) = @_;
    	    eval q({  &uint64_t  &midr;  &midr =  &READ_SPECIALREG( &midr_el1); ( &midr); });
	}' unless defined(&get_midr);
	eval 'sub get_mpidr {
	    my($void) = @_;
    	    eval q({  &uint64_t  &mpidr;  &mpidr =  &READ_SPECIALREG( &mpidr_el1); ( &mpidr); });
	}' unless defined(&get_mpidr);
	eval 'sub clrex {
	    my($void) = @_;
    	    eval q({  &__asm  &__volatile(\\"clrex\\" : : : \\"memory\\"); });
	}' unless defined(&clrex);
	eval 'sub cpu_nullop () {
	    eval q( &arm64_nullop());
	}' unless defined(&cpu_nullop);
	eval 'sub cpufunc_nullop () {
	    eval q( &arm64_nullop());
	}' unless defined(&cpufunc_nullop);
	eval 'sub cpu_setttb {
	    my($a) = @_;
    	    eval q( &arm64_setttb($a));
	}' unless defined(&cpu_setttb);
	eval 'sub cpu_tlb_flushID () {
	    eval q( &arm64_tlb_flushID());
	}' unless defined(&cpu_tlb_flushID);
	eval 'sub cpu_dcache_wbinv_range {
	    my($a, $s) = @_;
    	    eval q( &arm64_dcache_wbinv_range(($a), ($s)));
	}' unless defined(&cpu_dcache_wbinv_range);
	eval 'sub cpu_dcache_inv_range {
	    my($a, $s) = @_;
    	    eval q( &arm64_dcache_inv_range(($a), ($s)));
	}' unless defined(&cpu_dcache_inv_range);
	eval 'sub cpu_dcache_wb_range {
	    my($a, $s) = @_;
    	    eval q( &arm64_dcache_wb_range(($a), ($s)));
	}' unless defined(&cpu_dcache_wb_range);
	eval 'sub cpu_idcache_wbinv_range {
	    my($a, $s) = @_;
    	    eval q( &arm64_idcache_wbinv_range(($a), ($s)));
	}' unless defined(&cpu_idcache_wbinv_range);
	eval 'sub cpu_icache_sync_range {
	    my($a, $s) = @_;
    	    eval q( &arm64_icache_sync_range(($a), ($s)));
	}' unless defined(&cpu_icache_sync_range);
    }
}
1;
